#ifndef BIN2HFW_H
#define BIN2HFW_H

#include <sys/types.h>
#include <unistd.h>
#include "hermesfw.h"
#include "hfw.h"

int src_endian;
int dst_endian;

struct content {
	unsigned long offset;
	unsigned short length;
	unsigned char *data;
};

struct segmrecord {
	unsigned long offset;
	unsigned long length;
	unsigned long unknown;
};

struct firmware {
        unsigned char *content1;
        unsigned char *content2;
        unsigned long address;                  /* entrypoint for RAM DL - 0 for Flash DL */
        unsigned char *plugrecords;
        unsigned char *segmrecords;
        unsigned char *inforecords;
        unsigned char *infocompat;
        unsigned char *infobuild;
        unsigned char *infoidentity;
};

int check_segments(struct segmrecord *segms, struct content *cnts);
		  
int read_bin_content(int fd, struct content *cnt);

struct segmrecord *read_bin_segms(int fd);
struct plugrecord *read_bin_plugs(int fd);

int write_asc_cnt_segms(FILE *fl, struct segmrecord *segms, struct content *cnts);

int read_bin_content_from(int fd, off_t offset, struct content *cnt);

struct segmrecord *read_bin_segms_from(int fd, off_t offset);

struct plugrecord *read_bin_plugs_from(int fd, off_t offset);

#endif /* BIN2HFW_H */
