/*
 * binfw2hfw - hermes wavelan cards firmware extracter
 *
 * Copyright (c) 2003, Benedikt 'Hunz' Heinz <hermesap@hunz.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */
 
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include "hfw.h"
#include "bin2hfw.h"
#include "hermesfw.h"

int main(int argc, char **argv) {
	struct plugrecord *plugs;
	struct segmrecord *segs;
	struct content cnt[100];
	int fd,count;
	
	src_endian= __BIG_ENDIAN; //__LITTLE_ENDIAN;
	if((argc<5) || ((fd=open(argv[1],O_RDONLY))<0)) {
		fprintf(stderr,"usage: %s <file> <plugs-ofs> <segms-ofs> <segm_1> ... <segm_n> \n",argv[0]);
		return 0;
	}
	if(!(plugs=read_bin_plugs_from(fd,strtoul(argv[2],NULL,0)))) {
		fprintf(stderr,"plugrecords seem to be invalid\n");
		return -1;
	}
	if(!(segs=read_bin_segms_from(fd,strtoul(argv[3],NULL,0)))) {
		fprintf(stderr,"segmentrecords seem to be invalid\n");
		return -1;
	}
	for(count=0;count<argc-4;count++) {
		if(read_bin_content_from(fd,strtoul(argv[count+4],NULL,0),cnt+count)) {
			fprintf(stderr,"segment %d seems to be invalid\n",count+1);
			return -1;
		}
	}
	if(check_segments(segs, cnt)) {
		fprintf(stderr,"segments don't match\n");
		return -1;
	}
	write_hfw_plugs(stdout,plugs);
	write_asc_cnt_segms(stdout,segs,cnt);
	return 0;
}